# PmxPythonLib
---
## Overview
近藤科学製PMXサーボモータ用pythonのライブラリです。  
This is a python library for Kondo Kagaku Pmx servo motor.

## Description
近藤科学製PMXサーボモータをpythonで動かすためのライブラリです。  
This is a library for operating Kondo Kagaku's PMX servo motor with Python.　


LinuxPCやWindowsPC等Pythonがインストールされている環境で使用することができます。  
It can be used in environments where Python is installed, such as Linux and Windows.

このライブラリを使用することで、  
using this library
- PMXサーボモータの一通りのコマンドが実装しています。  
 A set of commands for PMX servo motor are implemented.
- pySerial経由でPMXサーボモータと通信することができるようになります。  
  You will be able to communicate with the PMX servo motor via pySerial.
- 位置制御はもちろんのこと、現在位置の取得や速度制御などのモードの切り替えの関数も用意しています。  
  In addition to position control, we also provide functions for obtaining the current position and switching modes such as speed control.
- PMXサーボモータを動かすためのサンプルプログラムを用意していますので、簡単に動かすことができます。  
  We have prepared a wide variety of sample programs for operating PMX servo motors, so you can easily operate them.
-    


  ...etc

## Revision History
### V1.0.0.0 (2023/10)
 - First Release
### V1.0.0.1 (2023/11)
- 軽微なバグを修正  
  Fixed minor bugs 
### V1.0.1.0 (2024/02)
- RamAddrListにショートブレーキ設定(530~)および目標指令値(700番台)のアドレスを追加しました  
  RamAddrList add [short brake],[GoalCommandValue]
- MotorWriteコマンドを使用せずMotorのON/OFFが設定する「setTorqueSwitch」関数を追加しました  
  Add function [setTorqueSwitch]
- setControlModeのwriteOptが反映されていなかったので修正しました   
  Fixed a bug where writeOpt of setControlMode was not reflected.

### V1.0.2.0(2024/07)
- PMXファームウェアバージョンV.1.1.0.0に対応する下記の機能を追加しました。 
  Added functionality compatible with PMX V.1.1.0.0.
  - 制御モードの組み合わせが追加されました  
    Added control mode combinations
  
  - RamAddrListに制御ゲイン、プリセットゲイン、LED点灯モードのアドレスを追加しました  
    Added address to RamAddrList
  - getPresetAllPidGainsほか制御ゲイン、プリセットゲイン関係の関数を追加しました  
    Added getPresetAllPidGains and other functions related to control gain and preset gain.
  - LED点灯モードに対応するgetLedMode、setLedMode関数を追加しました  
    Added getLedMode and setLedMode functions corresponding to LED lighting mode
  - エラーリストに実行エラーを追加しました  
    Added [Run error] to error list
  
- その他軽微なバグを修正しました   
  Fixed minor bugs 

## Contents
root/  
 ├PmxLib  
 ┃    ├ PmxLib.py  
 ┃    └ PmxPySerialClass.py  
 ├ sample  
 ┃    ├ MemREADSample_xxxxx.py  
 ┃    ┃    .....  
 ┃    └ (sample ...etc)  
 ├ template  
 ┃    └PmxTemplate_xxxxx.py    
 ├ readmeTop.md (this file)  
 ├ LICENSE.txt  
 └ PmxLib FunctionList V1_0_2_0(See to index.html)  
## Requirement
- Python 3  (check to Python3.12.3)
  + serial(pySerial) (check to 3.5)
  

## Usage
* ダウンロードし解凍が終わったら「PmxLib」「sample」をフォルダごとコピーしてください。

  Please do copying every the folder of「PmxLib」and「sample」 at the optional place.

  ※サンプルプログラムは相対パスで設定しています。

  ※A sample program establishes PmxLib by a relative path.

- PMXと接続に関しては
  [弊社HP](https://kondo-robot.com/)および
  [PMXサーボを使ってみよう　PCから制御「準備編」](https://kondo-robot.com/faq/pmx-servo-tutorial-pc1)
  をご覧ください。

  Please check the [OurHomePage](https://kondo-robot.com/) or [準備編](https://kondo-robot.com/faq/pmx-servo-tutorial-pc1)to connect with PMX.

* サンプルプログラムを実行してみてください

  Please execute a sample program.


## Licence
このプロジェクトはMIT Licenseです。
詳しくは同フォルダのLICENSE.txtをご覧ください。  
This project is licensed under the MIT License, see the LICENSE.txt file for details

## Author
近藤科学株式会社  07/2024  
Kondo Kagaku co.,ltd.  
近藤科学ホームページ:(<http://kondo-robot.com/>)
