#coding: UTF-8

#
#  @file PmxTemplate20231011.py
#  @brief PMX sample code Template
#  @author Kondo Kagaku Co.,Ltd.
#  @date 2023/10/19
#

#   
#   PmxTemplate20231011.pyはPMXのPythonライブラリを実行する際、最低限必要なソースコードです。
#   PmxTemplate20231011.py is the minimum source code required to run the PMX Python library.   
#

import sys
import os

#PmxLib import
# ライブラリのパスはフォルダの構成によって変わります
# 現在のスクリプトのディレクトリを取得
current_dir = os.path.dirname(__file__)
# 1つ上のフォルダを取得
parent_dir = os.path.dirname(current_dir)
# Pmxのライブラリのパスを登録
pmxLibPath = parent_dir + '\PmxLib'
sys.path.append(pmxLibPath)

from PmxPySerialClass  import PmxPySerialClass
from PmxLib import PmxLib as PMX


# instantiate PmxPySerialClass
pmx = PmxPySerialClass()

# 通信の設定項目
# Communication setting

#comName = "/dev/ttyUSB0"
comName = "COM3"
pmxBaudrate = 115200
pmxTimeout = 1.0


"""Serial open"""
def serialPortOpen():
    ###COM open
    openFlag = pmx.open(comName, baudrate=pmxBaudrate, timeout=pmxTimeout)
    if openFlag == False:
        print("Serial not open. Exit program")
        exit()
    else:
        print("Serial Connect success")
        



""" Main Func """
def main():


    # 通信ログを表示させる(表示：True,非表示：False)
    # Displaying communication log 
    pmx.logOutput = False

    # Serial port Open
    serialPortOpen()

    # トルクONの状態を取得する
    # Get torque ON status
    # TorqueSwitch Data: 0x01=TorqueON, 0x02=Free, 0x04=Brake, 0x08=Hold
    print('Get torque ON status')
    flag, data = pmx.getTorqueSwitch(0)  # id
    print(hex(flag), data)
    
    pmx.close()


""" main """
if __name__ == "__main__":
    main()
